
package _Observee;

####################################
# Class Variables

####################################
# Class Methods

sub Initialize {
	my($self) = shift;
	$self->{"observers"} = {};
}

####################################
# Instance Methods

sub RegisterAsObserver {
	my($self) = shift;
	my($observer) = shift;

	#&main::DebugLog("_Observee RegisterAsObserver $observer\n");
	${$self->{"observers"}}{$observer}="Registered";
}

sub UnregisterAsObserver {
	my($self) = shift;
        my($observer) = shift;

        delete ${$self->{"observers"}}{$observer};
}

sub NotifyObservers {
	my($self) = shift;

	#&main::DebugLog("_Observee NotifyObservers @_\n");
	my($observer);
	foreach $observer (keys %{$self->{"observers"}}){
		#&main::DebugLog("   Notifying $observer\n");
		#$observer->Notify(@_);
		View::Notify($observer,@_);
	}
}

1;
